import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormWarship extends JFrame {
    private DrawingWarship _warship;
    public DrawingComponents drawingComponents;
    private JPanel mainPanel;
    private JButton buttonCreate;
    private JButton buttonLeft;
    private JButton buttonUp;
    private JButton buttonDown;
    private JButton buttonRight;
    private JToolBar toolBar;
    private JLabel toolBarLabelSpeed;
    private JLabel toolBarLabelWieght;
    private JLabel toolBarLabelColor;
    private JPanel drawPanel;

    public FormWarship(){
        InitializeComponent();
    }
    private void Draw(){
        drawingComponents.repaint();
    }

    private void InitializeComponent(){
        setContentPane(mainPanel);
        setTitle("Warship");
        setSize(900,700);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setVisible(true);

        Icon iconUp = new ImageIcon("src\\Images\\ArrowUp.jpg");
        buttonUp.setIcon(iconUp);
        Icon iconDown = new ImageIcon("src\\Images\\ArrowDown.jpg");
        buttonDown.setIcon(iconDown);
        Icon iconLeft = new ImageIcon("src\\Images\\ArrowLeft.jpg");
        buttonLeft.setIcon(iconLeft);
        Icon iconRight = new ImageIcon("src\\Images\\ArrowRight.jpg");
        buttonRight.setIcon(iconRight);

        drawingComponents = new DrawingComponents();
        drawPanel.add(drawingComponents);
        buttonCreate.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Random rnd = new Random();
                _warship = new DrawingWarship();
                _warship.Init(rnd.nextInt(200) + 100, rnd.nextInt(1000) + 1000,
                        new Color(rnd.nextInt(256),rnd.nextInt(256),rnd.nextInt(256)));
                _warship.SetPosition(rnd.nextInt(90) + 10, rnd.nextInt(90) + 10, drawPanel.getWidth(), drawPanel.getHeight());
                toolBarLabelSpeed.setText("Color: " + _warship.GetWarship().GetSpeed() + "  ");
                toolBarLabelWieght.setText("Weight: " + _warship.GetWarship().GetWeight() + "  ");
                toolBarLabelColor.setText("Color: " + _warship.GetWarship().GetBodyColor().getRed() + " " +
                        _warship.GetWarship().GetBodyColor().getGreen() + " " + _warship.GetWarship().GetBodyColor().getBlue());
                drawingComponents.SetDrawingWarship(_warship);
                Draw();
            }
        });

        buttonLeft.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_warship != null) _warship.MoveTransport(Direction.Left);
                Draw();
            }
        });

        buttonRight.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_warship != null) _warship.MoveTransport(Direction.Right);
                Draw();
            }
        });

        buttonUp.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_warship != null) _warship.MoveTransport(Direction.Up);
                Draw();
            }
        });

        buttonDown.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(_warship != null) _warship.MoveTransport(Direction.Down);
                Draw();
            }
        });

        drawPanel.addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                _warship.ChangeBorders(drawPanel.getWidth(),drawPanel.getHeight());
                Draw();
            }
        });
    }
}
